﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace Eingabeverwaltung.Metamodell
{
	public class BuildingConstructor : Constructor
	{
		public readonly List<int> buildingParameters;
		public BuildingConstructor(string name,List<Sort> sorts) : base(name,sorts)
		{
			buildingParameters = new List<int>();
			for(int i=0; i< sorts.Count()-1; i++)
				if(sorts[i] == sorts.Last()) buildingParameters.Add(i);
			if (buildingParameters.Count == 0) throw new Exception("The constructor "+name+" has been falsely considered as building constructor.");
		}

		public override string ToString(bool showMetadata)
		{
			string res = base.ToString(showMetadata);
			if (showMetadata)
			{
				res += "     bulding Constructor on parameter ";
				foreach (int i in buildingParameters)
					res += i + " ";
				res += "\n";
			}
			return res;
		}
	}
}
