﻿using Eingabeverwaltung.Metamodell;
using System;
using System.Collections.Generic;

namespace Ueberpruefung.CheckTransformation
{
    public class CheckSubstitution_for_RuleEndTree : ElementChecker
    {
        public CheckSubstitution_for_RuleEndTree() { }

        public override bool check(Element el)
        {
            if (el is TransformationStep ts)
            {
                bool e = new CheckTermPart_match_RuleEndTree().check(ts),
                r = ts.termPart.Equals(CheckHelper.substitute(ts.ruleEndTree(), ts.substitutions));
                if (e && !r && !(new CheckTermPart_match_RuleStartTree().check(ts)))
                {
                    Error err = new Error(10);
                    err.Output = Util.ListSubstitutionToString(CheckHelper.findSubstitution(ts.ruleEndTree(),ts.termPart));
                    ts.errors.Add(err);
                }
                return !e || r;
            }
            else throw new InvalidOperationException();
        }
    }
}